#pragma CODE DEBUG OBJECTEXTEND

#include <reg552.h>
#include <stdio.h>
#include <stdlib.h>
#include <ctype.h>
#include <rtx51.h>

#define	SYSTEM	0
#define	CLOCK		1
#define	GETESC	2

#define ESC  		0x1B                // ESCAPE character code              

extern getline(char xdata*,char);  	//external function: input line
extern Serial_Init(void);

code char Table[]="Diversant Software inc.\n\r";

xdata char inline[32];   						//storage for command input line

struct Time
{
 unsigned char Hod,Min,Sek;
};

struct Time Cas = {6,15,0};

bit showtime;

void Clock(void) _task_ CLOCK _priority_ 0
{
 showtime=0;
 while(1)
  {
	 os_wait(K_IVL,100,NULL);
	 if(showtime) os_send_signal(SYSTEM);
	 if(++Cas.Sek==60)
	  {
		 Cas.Sek=0;
		 if(++Cas.Min==60)
		  {
			 Cas.Min=0;
			 if(++Cas.Hod==24)
			  {
				 Cas.Hod=0;
				}
			}
		}
	}
}

bit	escape;                         // flag: mark ESC character entered   

void Get_escape(void) _task_ GETESC _priority_ 0
{
  while(1)
	 {                                // endless loop              
		switch(_getkey())								// set flag if ESC entered
		 {
			case	ESC		:	
			case	'\n'	:	escape=1; break;
		 }
    if(escape) os_send_signal(SYSTEM);
  }
}

void System(void) _task_ SYSTEM _priority_ 0
{
 signed char RtxCompletion;
// unsigned char i;
 int argsread;
 Serial_Init();
 os_create_task(CLOCK);
 while(1)
  {
	 RtxCompletion=os_wait(K_TMO,50,NULL);
	 printf("Nastav cas v tvare: HH:MM:SS\r\n");
	 getline(&inline,sizeof(inline));        											//get command line input
//   for(i=0; inline[i]!=0; i++) inline[i]=toupper(inline[i]);		//convert to uppercase
//   for(i=0; inline[i]!=0; i++) inline[i]=tolower(inline[i]);		//convert to lowercase	 
//   for(i=0; inline[i]==' '; i++);        												//skip blanks
//-----------------------------------------------------------------------------------------
	 if(argsread=sscanf(inline,"%02bd:%02bd:%02bd",&Cas.Hod,&Cas.Min,&Cas.Sek)!=3);
//-----------------------------------------------------------------------------------------
	 os_create_task(GETESC);
	 os_clear_signal(SYSTEM);
	 escape=0; showtime=1;
	 while(!escape)
	  {
		 printf("%02bd:%02bd:%02bd\r",Cas.Hod,Cas.Min,Cas.Sek);
		 os_wait(K_SIG,0x00,NULL);
		}
	 showtime=0;	
	 os_delete_task(GETESC);
	}
}

void main(void)
{
 signed char RtxCompletion;
 RtxCompletion=os_start_system(SYSTEM);
}